/*
* jQuery TUKUMEMO SNOW 0.0.1
* http://tukumemo.com/
* Copyright 2014 TUKUMEMO
* license: http://www.opensource.org/licenses/mit-license.php
*/
;(function($ ,document, window) {
    var pgName = 'tukumemoSnow';
    //
    //css3が使える場合
    var cssParam = {},
        cssInit = function() {
            var style = document.createElement('div').style;
            if ('webkitTransition' in style) {
                cssParam.vender = '-webkit-';
                cssParam.venderFunc = 'webkitTransitionEnd';
                return true;
            } else if ('transition' in style) {
                cssParam.vender = '';
                cssParam.venderFunc = 'transitionend';
                return true;
            } else {
                return false;
            }
        },
        isCssAnime = cssInit();
    //
    //本体plugin
    $[pgName] = function(elem, option) {
        var plugin = this,
            $elem = $(elem),
            defaults = {
                targetClass: 'snow',             //オブジェクトのクラス
                direction: 'top',                //top,bottom
                size:{max: 60, min: 10},         //オブジェクトのサイズ
                objectMax: 20,                   //オブジェクトの数
                wind: 100,                       //風
                speed: 1000,                     //オブジェクトの速度
                swing: {max:10, min:1, speed:800},//オブジェクトの揺れ幅
                imgpath: ''                      //オブジェクトの画像パス
            },
            delayNum = 800;
        plugin.settings = {};
        //
        //生成
        var created = function() {
            if (!plugin.settings.imgpath){
                return false;
            }
            var img = document.createElement('img');
            img.src = plugin.settings.imgpath;
            $(img).on('load',function(){
                for (var i = 0; i < plugin.settings.objectMax; i += 1) {
                    $elem.append('<img src="' + plugin.settings.imgpath + '" class="' + plugin.settings.targetClass + '" />');
                }
                plugin.played();
            });
        };
        //動き
        var moved = function(obj) {
            var size = sizeSet(),
                pos = posSet(),
                times = timeSet(size,pos);

            $(obj).stop().css({ width: size + 'px'});

            if (isCssAnime) {
                 $(obj).off()
                 .css(cssParam.vender + 'transform', 'translate(' + pos.started.x + 'px,' + pos.started.y + 'px)')
                 .delay(100)
                 .queue(function(){
                    $(this)
                    .css(cssParam.vender + 'transform', 'translate(' + pos.ended.x + 'px,' + pos.ended.y + 'px)')
                    .css(cssParam.vender + 'transition', cssParam.vender + 'transform ' + times + 'ms linear')
                    .dequeue();
                 })
                 .on(cssParam.venderFunc, function() {
                    $(this)
                    .css(cssParam.vender + 'transition', '')
                    .css(cssParam.vender + 'transform', '');
                    moved(this);
                });
            } else {
                $(obj)
                .css({ top: pos.started.y + 'px', left: pos.started.x + 'px'})
                .animate({ top: pos.ended.y + 'px', left: pos.ended.x + 'px'}, { duration:times, queue:false, complete:function(){
                    moved(this);
                }});
            }
            swings(obj);
        };
        //揺れ
        var swings = function(obj) {
            var mhNum = Math.floor(Math.random() * (plugin.settings.swing.max - plugin.settings.swing.min) + plugin.settings.swing.min ) * -1;
            $(obj).animate({marginLeft: mhNum + 'px'}, {duration:plugin.settings.swing.speed, queue:false, complete:function(){
                $(obj).animate({marginLeft: 0}, {duration:plugin.settings.swing.speed, queue:false, complete:function(){
                    swings(obj);
                }});
            }});
        };
        //時間
        var timeSet = function(size,pos){
            var rate = plugin.settings.speed / (800 * size / plugin.settings.size.max);
            return Math.floor(Math.abs(pos.started.y - pos.ended.y) * rate);
        };
        //ポジション
        var posSet = function() {
            var pos = {},
                delay = {},
                $win = $(window),
                started,
                winWidth = $win.width(),
                winHeight = $win.height(),
                range = Math.abs(plugin.settings.wind);

            delay.started = Math.floor(Math.random() * delayNum);
            delay.ended = Math.floor(Math.random() * delayNum);
            pos.started = {};
            pos.ended = {};

            switch(plugin.settings.direction){
                case 'top':
                    pos.started.y = 0 - delay.started;
                    pos.ended.y = winHeight + delay.ended;
                    pos.started.x = Math.floor(Math.random() * (winWidth + range) - range);
                    pos.ended.x = pos.started.x + plugin.settings.wind;
                break;
                case 'bottom':
                    pos.started.y = winHeight + delay.ended;
                    pos.ended.y = 0 - delay.started;
                    pos.started.x = Math.floor(Math.random() * (winWidth + range) - range);
                    pos.ended.x = pos.started.x + plugin.settings.wind;
                break;
            }
            return pos;
        };
        //サイズ
        var sizeSet = function() {
            return Math.floor(Math.random() * (plugin.settings.size.max - plugin.settings.size.min) + plugin.settings.size.min);
        };
        //
        //style tag 確保
        var cssStyleSet = function() {
            var cssStyle = document.createElement('style');
            cssStyle.setAttribute('type', 'text/css');
            $(cssStyle).appendTo('head')[0];
            cssStyle.sheet.insertRule('.' + plugin.settings.targetClass + '{position:fixed; left:0; top:0;}', 0);
        };
        //method
        //停止
        plugin.stoped = function() {
            var pos = posSet();
            $('.' + plugin.settings.targetClass).each(function() {
                $(this).stop();
                if (isCssAnime) {
                    $(this)
                    .css(cssParam.vender + 'transform', 'translate(' + pos.started.x + 'px,' + pos.started.y + 'px)')
                    .css(cssParam.vender + 'transition', '');
                } else {
                    $(this).css({ top: pos.started.y + 'px', left: pos.started.x + 'px'});
                }
            });
        };
        //再生
        plugin.played = function() {
            $('.' + plugin.settings.targetClass).each(function() {
                moved(this);
            });
        };
        //init
        var init = function() {
            plugin.settings = $.extend(defaults, option);
            cssStyleSet();
            created();
            $(window).on('resize',function(){
                plugin.stoped ();
                plugin.played();
            });
        };
        init();
    };
    $.fn[pgName] = function(option) {
        return this.each(function() {
            if (undefined === $(this).data(pgName)) {
                var plugin = new $[pgName](this, option);
                $(this).data(pgName, plugin);
            }
        });
    };
})(jQuery, document, window);
